]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
tests/smime: Always use --batch with gpgsm
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For emacsclient
108 unset ALTERNATE_EDITOR
109
110 add_gnupg_home ()
111 {
112     local output
113     [ -d ${GNUPGHOME} ] && return
114     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
115     at_exit_function _gnupg_exit
116     mkdir -m 0700 "$GNUPGHOME"
117     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
118     test_debug "cat $GNUPGHOME/import.log"
119     if (gpg --quick-random --version >/dev/null 2>&1) ; then
120         echo quick-random >> "$GNUPGHOME"/gpg.conf
121     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
122         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
123     fi
124     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
125
126     # Change this if we ship a new test key
127     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
128     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
129     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
130 }
131
132 add_gpgsm_home ()
133 {
134     local fpr
135     [ -d ${GNUPGHOME} ] && return
136     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
137     at_exit_function _gnupg_exit
138     mkdir -m 0700 "$GNUPGHOME"
139     gpgsm --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/test.crt >"$GNUPGHOME"/import.log 2>&1
140     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
141     echo "$fpr S relax" >> $GNUPGHOME/trustlist.txt
142     test_debug "cat $GNUPGHOME/import.log"
143 }
144
145 # Each test should start with something like this, after copyright notices:
146 #
147 # test_description='Description of this test...
148 # This test checks if command xyzzy does the right thing...
149 # '
150 # . ./test-lib.sh || exit 1
151
152 color=maybe
153
154 while test "$#" -ne 0
155 do
156         case "$1" in
157         -d|--debug)
158                 debug=t; shift ;;
159         -i|--immediate)
160                 immediate=t; shift ;;
161         -h|--help)
162                 help=t; shift ;;
163         -v|--verbose)
164                 verbose=t; shift ;;
165         -q|--quiet)
166                 quiet=t; shift ;;
167         --with-dashes)
168                 with_dashes=t; shift ;;
169         --no-color)
170                 color=; shift ;;
171         --no-python)
172                 # noop now...
173                 shift ;;
174         --valgrind)
175                 valgrind=t; verbose=t; shift ;;
176         --tee)
177                 shift ;; # was handled already
178         *)
179                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
180         esac
181 done
182
183 if test -n "$debug"; then
184     print_subtest () {
185         printf " %-4s" "[$((test_count - 1))]"
186     }
187 else
188     print_subtest () {
189         true
190     }
191 fi
192
193 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
194
195 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
196                 TERM=$ORIGINAL_TERM &&
197                 export TERM &&
198                 tput bold
199                 tput setaf
200                 tput sgr0
201         ) >/dev/null 2>&1
202 then
203         color=t
204 else
205         color=
206 fi
207
208 if test -n "$color"; then
209         say_color () {
210                 (
211                 TERM=$ORIGINAL_TERM
212                 export TERM
213                 case "$1" in
214                         error) tput bold; tput setaf 1;; # bold red
215                         skip)  tput bold; tput setaf 2;; # bold green
216                         pass)  tput setaf 2;;            # green
217                         info)  tput setaf 3;;            # brown
218                         *) test -n "$quiet" && return;;
219                 esac
220                 shift
221                 printf " "
222                 printf "$@"
223                 tput sgr0
224                 print_subtest
225                 )
226         }
227 else
228         say_color() {
229                 test -z "$1" && test -n "$quiet" && return
230                 shift
231                 printf " "
232                 printf "$@"
233                 print_subtest
234         }
235 fi
236
237 error () {
238         say_color error "error: $*\n"
239         GIT_EXIT_OK=t
240         exit 1
241 }
242
243 say () {
244         say_color info "$*"
245 }
246
247 test "${test_description}" != "" ||
248 error "Test script did not set test_description."
249
250 if test "$help" = "t"
251 then
252         echo "Tests ${test_description}"
253         exit 0
254 fi
255
256 test_description_printed=
257 print_test_description ()
258 {
259         test -z "$test_description_printed" || return 0
260         echo
261         echo $this_test: "Testing ${test_description}"
262         test_description_printed=1
263 }
264 if [ -z "$NOTMUCH_TEST_QUIET" ]
265 then
266         print_test_description
267 fi
268
269 test_failure=0
270 test_count=0
271 test_fixed=0
272 test_broken=0
273 test_success=0
274
275 declare -a _exit_functions=()
276
277 at_exit_function () {
278         _exit_functions=($1 ${_exit_functions[@]/$1})
279 }
280
281 rm_exit_function () {
282         _exit_functions=(${_exit_functions[@]/$1})
283 }
284
285 _exit_common () {
286         code=$?
287         trap - EXIT
288         set +ex
289         for _fn in ${_exit_functions[@]}; do $_fn; done
290         rm -rf "$TEST_TMPDIR"
291 }
292
293 trap_exit () {
294         _exit_common
295         if test -n "$GIT_EXIT_OK"
296         then
297                 exit $code
298         else
299                 exec >&6
300                 say_color error '%-6s' FATAL
301                 echo " $test_subtest_name"
302                 echo
303                 echo "Unexpected exit while executing $0. Exit code $code."
304                 exit 1
305         fi
306 }
307
308 trap_signal () {
309         _exit_common
310         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
311         exit $code
312 }
313
314 die () {
315         _exit_common
316         exec >&6
317         say_color error '%-6s' FATAL
318         echo " $*"
319         echo
320         echo "Unexpected exit while executing $0."
321         exit 1
322 }
323
324 GIT_EXIT_OK=
325 # Note: TEST_TMPDIR *NOT* exported!
326 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
327 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
328 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
329 trap 'trap_exit' EXIT
330 trap 'trap_signal' HUP INT TERM
331
332 # Deliver a message with emacs and add it to the database
333 #
334 # Uses emacs to generate and deliver a message to the mail store.
335 # Accepts arbitrary extra emacs/elisp functions to modify the message
336 # before sending, which is useful to doing things like attaching files
337 # to the message and encrypting/signing.
338 emacs_deliver_message ()
339 {
340     local subject="$1"
341     local body="$2"
342     shift 2
343     # before we can send a message, we have to prepare the FCC maildir
344     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
345     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
346     local smtp_dummy_pid= smtp_dummy_port=
347     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
348     test -n "$smtp_dummy_pid" || return 1
349     test -n "$smtp_dummy_port" || return 1
350
351     test_emacs \
352         "(let ((message-send-mail-function 'message-smtpmail-send-it)
353                (mail-host-address \"example.com\")
354                (smtpmail-smtp-server \"localhost\")
355                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
356            (notmuch-mua-mail)
357            (message-goto-to)
358            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
359            (message-goto-subject)
360            (insert \"${subject}\")
361            (message-goto-body)
362            (insert \"${body}\")
363            $*
364            (notmuch-mua-send-and-exit))"
365
366     # In case message was sent properly, client waits for confirmation
367     # before exiting and resuming control here; therefore making sure
368     # that server exits by sending (KILL) signal to it is safe.
369     kill -9 $smtp_dummy_pid
370     notmuch new >/dev/null
371 }
372
373 # Pretend to deliver a message with emacs. Really save it to a file
374 # and add it to the database
375 #
376 # Uses emacs to generate and deliver a message to the mail store.
377 # Accepts arbitrary extra emacs/elisp functions to modify the message
378 # before sending, which is useful to doing things like attaching files
379 # to the message and encrypting/signing.
380 #
381 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
382 # at the head of the argument list, they are sent directly to "notmuch
383 # new" after message delivery
384 emacs_fcc_message ()
385 {
386     local nmn_args=''
387     while [[ "$1" =~ ^-- ]]; do
388         nmn_args="$nmn_args $1"
389         shift
390     done
391     local subject="$1"
392     local body="$2"
393     shift 2
394     # before we can send a message, we have to prepare the FCC maildir
395     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
396
397     test_emacs \
398         "(let ((message-send-mail-function (lambda () t))
399                (mail-host-address \"example.com\"))
400            (notmuch-mua-mail)
401            (message-goto-to)
402            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
403            (message-goto-subject)
404            (insert \"${subject}\")
405            (message-goto-body)
406            (insert \"${body}\")
407            $*
408            (notmuch-mua-send-and-exit))" || return 1
409     notmuch new $nmn_args >/dev/null
410 }
411
412 # Add an existing, fixed corpus of email to the database.
413 #
414 # $1 is the corpus dir under corpora to add, using "default" if unset.
415 #
416 # The default corpus is based on about 50 messages from early in the
417 # history of the notmuch mailing list, which allows for reliably
418 # testing commands that need to operate on a not-totally-trivial
419 # number of messages.
420 add_email_corpus ()
421 {
422     corpus=${1:-default}
423
424     rm -rf ${MAIL_DIR}
425     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
426     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
427 }
428
429 test_begin_subtest ()
430 {
431     if [ -n "$inside_subtest" ]; then
432         exec 1>&6 2>&7          # Restore stdout and stderr
433         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
434     fi
435     test_subtest_name="$1"
436     test_reset_state_
437     # Redirect test output to the previously prepared file descriptors
438     # 3 and 4 (see below)
439     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
440     exec >&3 2>&4
441     inside_subtest=t
442 }
443
444 # Pass test if two arguments match
445 #
446 # Note: Unlike all other test_expect_* functions, this function does
447 # not accept a test name. Instead, the caller should call
448 # test_begin_subtest before calling this function in order to set the
449 # name.
450 test_expect_equal ()
451 {
452         exec 1>&6 2>&7          # Restore stdout and stderr
453         if [ -z "$inside_subtest" ]; then
454                 error "bug in the test script: test_expect_equal without test_begin_subtest"
455         fi
456         inside_subtest=
457         test "$#" = 2 ||
458         error "bug in the test script: not 2 parameters to test_expect_equal"
459
460         output="$1"
461         expected="$2"
462         if ! test_skip "$test_subtest_name"
463         then
464                 if [ "$output" = "$expected" ]; then
465                         test_ok_
466                 else
467                         testname=$this_test.$test_count
468                         echo "$expected" > $testname.expected
469                         echo "$output" > $testname.output
470                         test_failure_ "$(diff -u $testname.expected $testname.output)"
471                 fi
472     fi
473 }
474
475 # Like test_expect_equal, but takes two filenames.
476 test_expect_equal_file ()
477 {
478         exec 1>&6 2>&7          # Restore stdout and stderr
479         if [ -z "$inside_subtest" ]; then
480                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
481         fi
482         inside_subtest=
483         test "$#" = 2 ||
484         error "bug in the test script: not 2 parameters to test_expect_equal_file"
485
486         file1="$1"
487         file2="$2"
488         if ! test_skip "$test_subtest_name"
489         then
490                 if diff -q "$file1" "$file2" >/dev/null ; then
491                         test_ok_
492                 else
493                         testname=$this_test.$test_count
494                         basename1=`basename "$file1"`
495                         basename2=`basename "$file2"`
496                         cp "$file1" "$testname.$basename1"
497                         cp "$file2" "$testname.$basename2"
498                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
499                 fi
500     fi
501 }
502
503 # Like test_expect_equal, but arguments are JSON expressions to be
504 # canonicalized before diff'ing.  If an argument cannot be parsed, it
505 # is used unchanged so that there's something to diff against.
506 test_expect_equal_json () {
507     # The test suite forces LC_ALL=C, but this causes Python 3 to
508     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
509     # override Python's stdio encoding defaults.
510     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
511     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
512         || echo "$1")
513     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
514         || echo "$2")
515     shift 2
516     test_expect_equal "$output" "$expected" "$@"
517 }
518
519 # Sort the top-level list of JSON data from stdin.
520 test_sort_json () {
521     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
522         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
523 }
524
525 # test for json objects:
526 # read the source of test/json_check_nodes.py (or the output when
527 # invoking it without arguments) for an explanation of the syntax.
528 test_json_nodes () {
529         exec 1>&6 2>&7          # Restore stdout and stderr
530         if [ -z "$inside_subtest" ]; then
531                 error "bug in the test script: test_json_eval without test_begin_subtest"
532         fi
533         inside_subtest=
534         test "$#" > 0 ||
535             error "bug in the test script: test_json_nodes needs at least 1 parameter"
536
537         if ! test_skip "$test_subtest_name"
538         then
539             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON "$TEST_DIRECTORY"/json_check_nodes.py "$@")
540                 if [ "$?" = 0 ]
541                 then
542                         test_ok_
543                 else
544                         test_failure_ "$output"
545                 fi
546         fi
547 }
548
549 test_emacs_expect_t () {
550         test "$#" = 1 ||
551         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
552         if [ -z "$inside_subtest" ]; then
553                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
554         fi
555
556         # Run the test.
557         if ! test_skip "$test_subtest_name"
558         then
559                 test_emacs "(notmuch-test-run $1)" >/dev/null
560
561                 # Restore state after the test.
562                 exec 1>&6 2>&7          # Restore stdout and stderr
563                 inside_subtest=
564
565                 # Report success/failure.
566                 result=$(cat OUTPUT)
567                 if [ "$result" = t ]
568                 then
569                         test_ok_
570                 else
571                         test_failure_ "${result}"
572                 fi
573         else
574                 # Restore state after the (non) test.
575                 exec 1>&6 2>&7          # Restore stdout and stderr
576                 inside_subtest=
577         fi
578 }
579
580 NOTMUCH_NEW ()
581 {
582     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
583 }
584
585 NOTMUCH_DUMP_TAGS ()
586 {
587     # this relies on the default format being batch-tag, otherwise some tests will break
588     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
589 }
590
591 notmuch_drop_mail_headers ()
592 {
593     $NOTMUCH_PYTHON -c '
594 import email, sys
595 msg = email.message_from_file(sys.stdin)
596 for hdr in sys.argv[1:]: del msg[hdr]
597 print(msg.as_string(False))
598 ' "$@"
599 }
600
601 notmuch_search_sanitize ()
602 {
603     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
604 }
605
606 notmuch_search_files_sanitize ()
607 {
608     notmuch_dir_sanitize
609 }
610
611 notmuch_dir_sanitize ()
612 {
613     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
614 }
615
616 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
617 notmuch_show_sanitize ()
618 {
619     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
620 }
621 notmuch_show_sanitize_all ()
622 {
623     sed \
624         -e 's| filename:.*| filename:XXXXX|' \
625         -e 's| id:[^ ]* | id:XXXXX |' | \
626         notmuch_date_sanitize
627 }
628
629 notmuch_json_show_sanitize ()
630 {
631     sed \
632         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
633         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
634         -e 's|"filename": "signature.asc",||g' \
635         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
636         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
637         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
638 }
639
640 notmuch_emacs_error_sanitize ()
641 {
642     local command=$1
643     shift
644     for file in "$@"; do
645         echo "=== $file ==="
646         cat "$file"
647     done | sed  \
648         -e 's/^\[.*\]$/[XXX]/' \
649         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
650 }
651
652 notmuch_date_sanitize ()
653 {
654     sed \
655         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
656 }
657
658 notmuch_uuid_sanitize ()
659 {
660     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
661 }
662
663 notmuch_built_with_sanitize ()
664 {
665     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
666 }
667
668 notmuch_config_sanitize ()
669 {
670     notmuch_dir_sanitize | notmuch_built_with_sanitize
671 }
672
673 notmuch_show_part ()
674 {
675     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
676 }
677
678 # End of notmuch helper functions
679
680 # Use test_set_prereq to tell that a particular prerequisite is available.
681 #
682 # The prerequisite can later be checked for by using test_have_prereq.
683 #
684 # The single parameter is the prerequisite tag (a simple word, in all
685 # capital letters by convention).
686
687 test_set_prereq () {
688         satisfied="$satisfied$1 "
689 }
690 satisfied=" "
691
692 test_have_prereq () {
693         case $satisfied in
694         *" $1 "*)
695                 : yes, have it ;;
696         *)
697                 ! : nope ;;
698         esac
699 }
700
701 declare -A test_missing_external_prereq_
702 declare -A test_subtest_missing_external_prereq_
703
704 # declare prerequisite for the given external binary
705 test_declare_external_prereq () {
706         binary="$1"
707         test "$#" = 2 && name=$2 || name="$binary(1)"
708
709         if ! hash $binary 2>/dev/null; then
710                 test_missing_external_prereq_["${binary}"]=t
711                 eval "
712 $binary () {
713         test_subtest_missing_external_prereq_[\"${name}\"]=t
714         false
715 }"
716         fi
717 }
718
719 # Explicitly require external prerequisite.  Useful when binary is
720 # called indirectly (e.g. from emacs).
721 # Returns success if dependency is available, failure otherwise.
722 test_require_external_prereq () {
723         binary="$1"
724         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
725                 # dependency is missing, call the replacement function to note it
726                 eval "$binary"
727         else
728                 true
729         fi
730 }
731
732 # You are not expected to call test_ok_ and test_failure_ directly, use
733 # the text_expect_* functions instead.
734
735 test_ok_ () {
736         if test "$test_subtest_known_broken_" = "t"; then
737                 test_known_broken_ok_
738                 return
739         fi
740         test_success=$(($test_success + 1))
741         if test -n "$NOTMUCH_TEST_QUIET"; then
742                 return 0
743         fi
744         say_color pass "%-6s" "PASS"
745         echo " $test_subtest_name"
746 }
747
748 test_failure_ () {
749         print_test_description
750         if test "$test_subtest_known_broken_" = "t"; then
751                 test_known_broken_failure_ "$@"
752                 return
753         fi
754         test_failure=$(($test_failure + 1))
755         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
756         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
757         return 1
758 }
759
760 test_failure_message_ () {
761         say_color error "%-6s" "$1"
762         echo " $2"
763         shift 2
764         if [ "$#" != "0" ]; then
765                 echo "$@" | sed -e 's/^/        /'
766         fi
767         if test "$verbose" != "t"; then cat test.output; fi
768 }
769
770 test_known_broken_ok_ () {
771         test_reset_state_
772         test_fixed=$(($test_fixed+1))
773         say_color pass "%-6s" "FIXED"
774         echo " $test_subtest_name"
775 }
776
777 test_known_broken_failure_ () {
778         test_reset_state_
779         test_broken=$(($test_broken+1))
780         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
781                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
782         else
783                 test_failure_message_ "BROKEN" "$test_subtest_name"
784         fi
785         return 1
786 }
787
788 test_debug () {
789         test "$debug" = "" || eval "$1"
790 }
791
792 test_run_ () {
793         test_cleanup=:
794         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
795         eval >&3 2>&4 "$1"
796         eval_ret=$?
797         eval >&3 2>&4 "$test_cleanup"
798         return 0
799 }
800
801 test_skip () {
802         test_count=$(($test_count+1))
803         to_skip=
804         for skp in $NOTMUCH_SKIP_TESTS
805         do
806                 case $this_test.$test_count in
807                 $skp)
808                         to_skip=t
809                         break
810                 esac
811                 case $this_test_bare.$test_count in
812                 $skp)
813                         to_skip=t
814                         break
815                 esac
816         done
817         case "$to_skip" in
818         t)
819                 test_report_skip_ "$@"
820                 ;;
821         *)
822                 test_check_missing_external_prereqs_ "$@"
823                 ;;
824         esac
825 }
826
827 test_check_missing_external_prereqs_ () {
828         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
829                 say_color skip >&1 "missing prerequisites: "
830                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
831                 test_report_skip_ "$@"
832         else
833                 false
834         fi
835 }
836
837 test_report_skip_ () {
838         test_reset_state_
839         say_color skip >&3 "skipping test:"
840         echo " $@" >&3
841         say_color skip "%-6s" "SKIP"
842         echo " $1"
843 }
844
845 test_subtest_known_broken () {
846         test_subtest_known_broken_=t
847 }
848
849 test_expect_success () {
850         exec 1>&6 2>&7          # Restore stdout and stderr
851         if [ -z "$inside_subtest" ]; then
852                 error "bug in the test script: test_expect_success without test_begin_subtest"
853         fi
854         inside_subtest=
855         test "$#" = 1 ||
856         error "bug in the test script: not 1 parameters to test_expect_success"
857
858         if ! test_skip "$test_subtest_name"
859         then
860                 test_run_ "$1"
861                 run_ret="$?"
862                 # test_run_ may update missing external prerequisites
863                 test_check_missing_external_prereqs_ "$@" ||
864                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
865                 then
866                         test_ok_
867                 else
868                         test_failure_ "$1"
869                 fi
870         fi
871 }
872
873 test_expect_code () {
874         exec 1>&6 2>&7          # Restore stdout and stderr
875         if [ -z "$inside_subtest" ]; then
876                 error "bug in the test script: test_expect_code without test_begin_subtest"
877         fi
878         inside_subtest=
879         test "$#" = 2 ||
880         error "bug in the test script: not 2 parameters to test_expect_code"
881
882         if ! test_skip "$test_subtest_name"
883         then
884                 test_run_ "$2"
885                 run_ret="$?"
886                 # test_run_ may update missing external prerequisites,
887                 test_check_missing_external_prereqs_ "$@" ||
888                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
889                 then
890                         test_ok_
891                 else
892                         test_failure_ "exit code $eval_ret, expected $1" "$2"
893                 fi
894         fi
895 }
896
897 # This is not among top-level (test_expect_success)
898 # but is a prefix that can be used in the test script, like:
899 #
900 #       test_expect_success 'complain and die' '
901 #           do something &&
902 #           do something else &&
903 #           test_must_fail git checkout ../outerspace
904 #       '
905 #
906 # Writing this as "! git checkout ../outerspace" is wrong, because
907 # the failure could be due to a segv.  We want a controlled failure.
908
909 test_must_fail () {
910         "$@"
911         test $? -gt 0 -a $? -le 129 -o $? -gt 192
912 }
913
914 # test_cmp is a helper function to compare actual and expected output.
915 # You can use it like:
916 #
917 #       test_expect_success 'foo works' '
918 #               echo expected >expected &&
919 #               foo >actual &&
920 #               test_cmp expected actual
921 #       '
922 #
923 # This could be written as either "cmp" or "diff -u", but:
924 # - cmp's output is not nearly as easy to read as diff -u
925 # - not all diff versions understand "-u"
926
927 test_cmp() {
928         $GIT_TEST_CMP "$@"
929 }
930
931 # This function can be used to schedule some commands to be run
932 # unconditionally at the end of the test to restore sanity:
933 #
934 #       test_expect_success 'test core.capslock' '
935 #               git config core.capslock true &&
936 #               test_when_finished "git config --unset core.capslock" &&
937 #               hello world
938 #       '
939 #
940 # That would be roughly equivalent to
941 #
942 #       test_expect_success 'test core.capslock' '
943 #               git config core.capslock true &&
944 #               hello world
945 #               git config --unset core.capslock
946 #       '
947 #
948 # except that the greeting and config --unset must both succeed for
949 # the test to pass.
950
951 test_when_finished () {
952         test_cleanup="{ $*
953                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
954 }
955
956 test_done () {
957         GIT_EXIT_OK=t
958         test_results_dir="$TEST_DIRECTORY/test-results"
959         mkdir -p "$test_results_dir"
960         test_results_path="$test_results_dir/$this_test"
961
962         echo "total $test_count" >> $test_results_path
963         echo "success $test_success" >> $test_results_path
964         echo "fixed $test_fixed" >> $test_results_path
965         echo "broken $test_broken" >> $test_results_path
966         echo "failed $test_failure" >> $test_results_path
967         echo "" >> $test_results_path
968
969         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
970
971         if [ "$test_failure" = "0" ]; then
972             if [ "$test_broken" = "0" ]; then
973                 rm -rf "$remove_tmp"
974             fi
975             exit 0
976         else
977             exit 1
978         fi
979 }
980
981 emacs_generate_script () {
982         # Construct a little test script here for the benefit of the user,
983         # (who can easily run "run_emacs" to get the same emacs environment
984         # for investigating any failures).
985         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
986 #!/bin/sh
987 export PATH=$PATH
988 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
989
990 # Here's what we are using here:
991 #
992 # --quick              Use minimal customization. This implies --no-init-file,
993 #                      --no-site-file and (emacs 24) --no-site-lisp
994 #
995 # --directory           Ensure that the local elisp sources are found
996 #
997 # --load                Force loading of notmuch.el and test-lib.el
998
999 exec ${TEST_EMACS} --quick \
1000         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
1001         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
1002         "\$@"
1003 EOF
1004         chmod a+x "$TMP_DIRECTORY/run_emacs"
1005 }
1006
1007 test_emacs () {
1008         # test dependencies beforehand to avoid the waiting loop below
1009         missing_dependencies=
1010         test_require_external_prereq dtach || missing_dependencies=1
1011         test_require_external_prereq emacs || missing_dependencies=1
1012         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1013         test -z "$missing_dependencies" || return
1014
1015         if [ -z "$EMACS_SERVER" ]; then
1016                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1017                 if [ -f "$emacs_tests" ]; then
1018                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1019                 else
1020                         load_emacs_tests=
1021                 fi
1022                 server_name="notmuch-test-suite-$$"
1023                 # start a detached session with an emacs server
1024                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1025                 # or unknown) is given to dtach which assumes a minimally
1026                 # VT100-compatible terminal -- and emacs inherits that
1027                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1028                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1029                                 --no-window-system \
1030                                 $load_emacs_tests \
1031                                 --eval '(setq server-name \"$server_name\")' \
1032                                 --eval '(server-start)' \
1033                                 --eval '(orphan-watchdog $$)'" || return
1034                 EMACS_SERVER="$server_name"
1035                 # wait until the emacs server is up
1036                 until test_emacs '()' >/dev/null 2>/dev/null; do
1037                         sleep 1
1038                 done
1039         fi
1040
1041         # Clear test-output output file.  Most Emacs tests end with a
1042         # call to (test-output).  If the test code fails with an
1043         # exception before this call, the output file won't get
1044         # updated.  Since we don't want to compare against an output
1045         # file from another test, so start out with an empty file.
1046         rm -f OUTPUT
1047         touch OUTPUT
1048
1049         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1050 }
1051
1052 test_python() {
1053     # Note: if there is need to print debug information from python program,
1054     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1055     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1056         $NOTMUCH_PYTHON -B - > OUTPUT
1057 }
1058
1059 test_ruby() {
1060     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1061 }
1062
1063 test_C () {
1064     exec_file="test${test_count}"
1065     test_file="${exec_file}.c"
1066     cat > ${test_file}
1067     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1068     echo "== stdout ==" > OUTPUT.stdout
1069     echo "== stderr ==" > OUTPUT.stderr
1070     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1071     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1072 }
1073
1074 make_shim () {
1075     base_name="$1"
1076     test_file="${base_name}.c"
1077     shim_file="${base_name}.so"
1078     cat > ${test_file}
1079     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1080 }
1081
1082 notmuch_with_shim () {
1083     base_name="$1"
1084     shift
1085     shim_file="${base_name}.so"
1086     LD_PRELOAD=./${shim_file}${LD_PRELOAD:+:$LD_PRELOAD} notmuch-shared "$@"
1087 }
1088
1089 # Creates a script that counts how much time it is executed and calls
1090 # notmuch.  $notmuch_counter_command is set to the path to the
1091 # generated script.  Use notmuch_counter_value() function to get the
1092 # current counter value.
1093 notmuch_counter_reset () {
1094         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1095         if [ ! -x "$notmuch_counter_command" ]; then
1096                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1097                 cat >"$notmuch_counter_command" <<EOF || return
1098 #!/bin/sh
1099
1100 read count < "$notmuch_counter_state_path"
1101 echo \$((count + 1)) > "$notmuch_counter_state_path"
1102
1103 exec notmuch "\$@"
1104 EOF
1105                 chmod +x "$notmuch_counter_command" || return
1106         fi
1107
1108         echo 0 > "$notmuch_counter_state_path"
1109 }
1110
1111 # Returns the current notmuch counter value.
1112 notmuch_counter_value () {
1113         if [ -r "$notmuch_counter_state_path" ]; then
1114                 read count < "$notmuch_counter_state_path"
1115         else
1116                 count=0
1117         fi
1118         echo $count
1119 }
1120
1121 test_reset_state_ () {
1122         test -z "$test_init_done_" && test_init_
1123
1124         test_subtest_known_broken_=
1125         test_subtest_missing_external_prereq_=()
1126 }
1127
1128 # called once before the first subtest
1129 test_init_ () {
1130         test_init_done_=t
1131
1132         # skip all tests if there were external prerequisites missing during init
1133         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1134 }
1135
1136
1137 # Where to run the tests
1138 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1139
1140 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1141
1142 emacs_generate_script
1143
1144
1145 # Use -P to resolve symlinks in our working directory so that the cwd
1146 # in subprocesses like git equals our $PWD (for pathname comparisons).
1147 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1148
1149 if test "$verbose" = "t"
1150 then
1151         exec 4>&2 3>&1
1152 else
1153         exec 4>test.output 3>&4
1154 fi
1155
1156 for skp in $NOTMUCH_SKIP_TESTS
1157 do
1158         to_skip=
1159         for skp in $NOTMUCH_SKIP_TESTS
1160         do
1161                 case "$this_test" in
1162                 $skp)
1163                         to_skip=t
1164                         break
1165                 esac
1166                 case "$this_test_bare" in
1167                 $skp)
1168                         to_skip=t
1169                         break
1170                 esac
1171         done
1172         case "$to_skip" in
1173         t)
1174                 say_color skip >&3 "skipping test $this_test altogether"
1175                 say_color skip "skip all tests in $this_test"
1176                 test_done
1177         esac
1178 done
1179
1180 # Provide an implementation of the 'yes' utility
1181 yes () {
1182         if test $# = 0
1183         then
1184                 y=y
1185         else
1186                 y="$*"
1187         fi
1188
1189         while echo "$y"
1190         do
1191                 :
1192         done
1193 }
1194
1195 # Fix some commands on Windows
1196 case $(uname -s) in
1197 *MINGW*)
1198         # Windows has its own (incompatible) sort and find
1199         sort () {
1200                 /usr/bin/sort "$@"
1201         }
1202         find () {
1203                 /usr/bin/find "$@"
1204         }
1205         sum () {
1206                 md5sum "$@"
1207         }
1208         # git sees Windows-style pwd
1209         pwd () {
1210                 builtin pwd -W
1211         }
1212         # no POSIX permissions
1213         # backslashes in pathspec are converted to '/'
1214         # exec does not inherit the PID
1215         ;;
1216 *)
1217         test_set_prereq POSIXPERM
1218         test_set_prereq BSLASHPSPEC
1219         test_set_prereq EXECKEEPSPID
1220         ;;
1221 esac
1222
1223 test -z "$NO_PERL" && test_set_prereq PERL
1224 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1225
1226 # test whether the filesystem supports symbolic links
1227 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1228 rm -f y
1229
1230 # convert variable from configure to more convenient form
1231 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1232     glass)
1233         db_ending=glass
1234     ;;
1235     chert)
1236         db_ending=DB
1237     ;;
1238     *)
1239         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1240 esac
1241 # declare prerequisites for external binaries used in tests
1242 test_declare_external_prereq dtach
1243 test_declare_external_prereq emacs
1244 test_declare_external_prereq ${TEST_EMACSCLIENT}
1245 test_declare_external_prereq ${TEST_GDB}
1246 test_declare_external_prereq gpg
1247 test_declare_external_prereq openssl
1248 test_declare_external_prereq gpgsm
1249 test_declare_external_prereq ${NOTMUCH_PYTHON}